<template>
  <div>
    <p class="title text-emerald-500 pb-5">Create category</p>
    <form>
      <TextInput
        label="Title"
        v-model="form.title"
        @input="validation('title')"
        :error="$v.title.$errors?.[0]?.$message.toString()"
      />
    </form>
    <div class="py-10 flex gap-x-5 justify-start">
      <button class="btn" @click="submitForm">Create category</button>
      <button class="btn" @click="refreshForm">Refresh from</button>
    </div>
  </div>
</template>

<script setup lang="ts">
import { useVuelidate } from "@vuelidate/core";
import { required, minLength } from "@vuelidate/validators";
import { useCategoriesStore } from "@/stores/categories";
import { useModalStore } from "@/stores/modal";

const { CloseFullscreenModal } = useModalStore();
const { GetCategories } = useCategoriesStore();

const rules = computed(() => ({
  title: {
    required,
    minLength: minLength(3),
  },
}));

const form = reactive({
  title: "",
});

const $v = useVuelidate(rules, form);

const validation = (inputName: string) => {
  $v.value[inputName].$touch();
};

const submitForm = () => {
  $v.value.$touch();
  const canSubmit = Object.values(form).every((e) => e);
  const formIsValid = !$v.value.$invalid;
  if (canSubmit && formIsValid) {
    sendCategory();
  }
};

const refreshForm = () => {
  const keys = Object.keys(form);
  keys.forEach((key: string) => {
    form[key as keyof typeof form] = "";
  });
  $v.value.$reset();
};

const sendCategory = async () => {
  try {
    await $fetch("/api/category/create", {
      method: "post",
      body: form,
    });
    useToast().success(`New Category [${form.title}] is created`);
    refreshForm();
    CloseFullscreenModal();
    GetCategories();
  } catch (error: any) {
    console.log(error);
    useToast().error("Ops! Create category is failed!");
  }
};
</script>
